#! /usr/local/bin/perl

#######################################################
#BooDataAnalyzer for CSV v1.01 / this script is free. #
#(C) BooBooClub 2001-2005                             #
#######################################################


#set data

$cgi = './bdanalyz.cgi';
$dat = './csvdata.csv';
$out = './output.csv';
$setdat = './dataset.txt';
$bar = './bar.gif';



#read lib
require './jcode.pl';


$ENV{'TZ'}='JST-9';
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = ($year + 1900);

$mon++;
if ($sec < 10) {	$sec = "0$sec";}
if ($min < 10) {	$min = "0$min";}
if ($hour < 10){	$hour = "0$hour";}
if ($mon < 10) {	$mon = "0$mon";}
if ($mday < 10){	$mday = "0$mday";}
$time = "$year/$mon/$mday $hour:$min:$sec";



#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/\cM\n//g;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	&jcode'convert(*value,'sjis');
	if($FORM{$name} eq ''){
		$FORM{$name} = $value;
	}
	else{
		$FORM{$name} .= ','.$value;
	}
}



#branch

if($FORM{'ws'}){
	$dat = $FORM{'datfile'};
	$out = $FORM{'outfile'};
	$head = $FORM{'dathead'};

	&ws_action;
}
elsif($FORM{'ss'}){
	$dat = $FORM{'datfile'};
	$out = $FORM{'outfile'};
	$head = $FORM{'dathead'};
	@head = split(/,/,$head);

	&ss_action;
}
elsif($FORM{'rs'}){
	$dat = $FORM{'datfile'};
	$out = $FORM{'outfile'};
	$head = $FORM{'dathead'};
	@head = split(/,/,$head);

	&rs_action;
}
else{
	open (HEAD,"$setdat");
	$hfile = join('',<HEAD>);
	close (HEAD);
	$hfile =~ s/\r\n|[\r\n]//g;
	$head = $hfile;

	&ready;
}



sub ws_action{

	$target = $FORM{'wsh'};

	open (DAT,"$dat");
	@dats = <DAT>;
	close (DAT);

	foreach $dats1(@dats){
		$w = 0;
		@edat1 = split(/,/,$dats1);
		foreach $dats2(@dats){
			@edat2 = split(/,/,$dats2);
			if($edat1[$target] eq $edat2[$target]){
				$w++;
			}
		}
		if($w >= 2){
			push(@wdat,$dats1);
		}
		else{
			push(@ndat,$dats1);
		}
	}

	if($FORM{'wdtype'} eq 'search'){
		@outdat = @wdat;
	}
	else{
		@outdat = @ndat;
	}

	if($FORM{'write'} eq 'yes'){
		if($FORM{'wtype'} eq 'rewrite'){
			open (OUT,">$out");
		}
		else{
			open (OUT,">>$out");
		}
		print OUT @outdat;
		close (OUT);
	}


	print "Content-type: text/html\n\n";
	print "<html><head><title>df[^</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<br><h2>df[^</h2><br><br>\n";
	if($FORM{'write'} eq 'yes'){
		print "OUTPUT-File = $out\n";
	}
	else{
		print "OUTPUT-File = t@Co͂͂Ȃ\n";
	}
	print "<br>\n";
	print "<br>\n";

	foreach $outdat(@outdat){
		print "<nobr>$outdat</nobr><br>\n";
	}

	print "<br></body></html>\n";
	exit 0;
}



sub ss_action{

	$target = $FORM{'ssh'};

	open (DAT,"$dat");
	@dats = <DAT>;
	close (DAT);

	$total = @dats;

	if($target eq 'all'){
		@target = (0..$#head);
	}
	else{
		@target = split(/,/,$target);
	}

	foreach $tdat(@target){
		if($head[$tdat] eq '' || $head[$tdat] =~ /^-+$/){
			next;
		}
		else{
			$ht .= $head[$tdat].',';
		}
		foreach $dats(@dats){
			@edat = split(/,/,$dats);
			$DAT{$head[$tdat]}{$edat[$tdat]}++;
		}
	}


	print "Content-type: text/html\n\n";
	print "<html><head><title>f[^Wv</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<br><h2>f[^Wv</h2><br><br>\n";
	if($target eq 'all'){
		print "\"ׂ\"";
	}
	else{
		chop $ht;
		print "\"$ht\"";
	}
	print "̍ڂ̃f[^Wv<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<table cellspacing=0 width=\"100%\">\n";

	foreach $tdat(@target){
		if($head[$tdat] eq '' || $head[$tdat] =~ /^-+$/){
			next;
		}
		print "<tr><td colspan=6 bgcolor=\"#ffdddd\"><b>$head[$tdat]</b></td></tr>\n";
		$i = 0;
		foreach $edat(sort keys %{$DAT{$head[$tdat]}}){
			if(($i % 2) != 0){
				$bgcolor = 'bgcolor=#eeeeee';
			}
			else{
				$bgcolor = '';
			}

			if($edat eq '' || $edat =~ /^[\s\Q@\E]+$/){
				print "<tr><td $bgcolor width=220><font size=2>[Null]</font></td>";
			}
			else{
				print "<tr><td $bgcolor width=220><font size=2>$edat</font></td>";
			}
			$per = (100 * ($DAT{$head[$tdat]}{$edat}) / $total);
			$per = (int($per * 100)) / 100;
			if($per !~ /\./){$per .= '.00';}
			elsif($per =~ /\.\d$/){$per .= '0';}
			print "<td $bgcolor width=10><font size=2><b>:</b></font></td>";
			print "<td $bgcolor align=right width=50><nobr>$DAT{$head[$tdat]}{$edat}</nobr></td>\n";
			print "<td $bgcolor align=right width=50><font size=2>($per\%)</font></td>";
			print "<td $bgcolor width=10><font size=2><b>:</b></font></td>";
			if($FORM{'sdtype'} eq 'graph'){
				$imgw = int($per * 2);
				print "<td $bgcolor align=left valign=middle><nobr><img src=\"$bar\" width=$imgw height=8></nobr></td></tr>\n";
			}
			else{
				print "<td $bgcolor align=left valign=middle><nobr></nobr></td></tr>\n";
			}
			$i++;
		}
	}

	print "</table>\n";
	print "<br></body></html>\n";
	exit 0;
}



sub rs_action{

	$target = $FORM{'rsh'};

	open (DAT,"$dat");
	@dats = <DAT>;
	close (DAT);

	foreach $dats(@dats){
		@edat = split(/,/,$dats);
		if(($target ne 'all' && $edat[$target] =~ /\Q$FORM{'stxt'}\E/) || ($target eq 'all' && $dats =~ /\Q$FORM{'stxt'}\E/)){
			push(@idat,$dats);
		}
		else{
			push(@udat,$dats);
		}
	}

	if($FORM{'sctype'} eq 'in'){
		@outdat = @idat;
	}
	else{
		@outdat = @udat;
	}

	if($FORM{'write'} eq 'yes'){
		if($FORM{'wtype'} eq 'rewrite'){
			open (OUT,">$out");
		}
		else{
			open (OUT,">>$out");
		}
		print OUT @outdat;
		close (OUT);
	}


	print "Content-type: text/html\n\n";
	print "<html><head><title>f[^</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<br><h2>f[^</h2><br><br>\n";
	if($target eq 'all'){
		print "\"ꂩ\"";
	}
	else{
		print "\"$head[$target]\"";
	}
	print "̍ڂ\"$FORM{'stxt'}\"";
	if($FORM{'sctype'} eq 'in'){
		print "܂ރf[^<br>\n";
	}
	else{
		print "܂܂Ȃf[^<br>\n";
	}
	print "<br>\n";

	if($FORM{'write'} eq 'yes'){
		print "OUTPUT-File = $out\n";
	}
	else{
		print "OUTPUT-File = t@Co͂͂Ȃ\n";
	}
	print "<br>\n";
	print "<br>\n";

	foreach $outdat(@outdat){
		print "<nobr>$outdat</nobr><br>\n";
	}

	print "<br></body></html>\n";
	exit 0;
}



sub ready{

	print "Content-type: text/html\n\n";
	print "<html><head><title>BooDataAnalyzer for CSV</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<center>\n";
	print "<table><tr><td>\n";
	print "<br><h2>Boo Data Analyzer for CSV</h2>|@brut@Cpf[^WvVXe@|@<br><br><br>\n";
	print "<form action=\"$cgi\" method=POST>\n";
	print "Ώۃt@CF<input name=\"datfile\" value=\"$dat\" size=40><br>\n";
	print "o̓t@CF<input name=\"outfile\" value=\"$out\" size=40>@<input type=checkbox name=\"write\" value=\"yes\">ۑ<br>\n";
	print "ۑ^Cv@F<input type=radio name=\"wtype\" value=\"rewrite\" checked>㏑@@@\n";
	print "<input type=radio name=\"wtype\" value=\"add\">ǋL<br>\n";
	print "f[^ږF<input name=\"dathead\" value=\"$head\" size=60><br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";

	print "dڏF<select name=\"wsh\">";
	@head = split(/,/,$head);
	$i = 0;
	foreach $ehead(@head){
		print "<option value=\"$i\">$ehead\n";
		$i++;
	}
	print "</select>\n";
	print "<input type=radio name=\"wdtype\" value=\"search\" checked>o@\n";
	print "<input type=radio name=\"wdtype\" value=\"remove\">폜\n";
	print "<input type=submit name=\"ws\" value=\"@@s@\"><br>\n";
	print "<font color=\"#ff8888\" size=2>Iڂɂēlf[^ꍇ̒o폜</font><br>\n";
	print "<br>\n";
	print "<br>\n";

	print "f[^̏WvF<select name=\"ssh\" size=4 multiple align=top>";
	@head = split(/,/,$head);
	print "<option value=\"all\" selected>SڑΏ\n";
	$i = 0;
	foreach $ehead(@head){
		print "<option value=\"$i\">$ehead\n";
		$i++;
	}
	print "</select>\n";
	print "<input type=radio name=\"sdtype\" value=\"graph\" checked>Ot\n";
	print "<input type=radio name=\"sdtype\" value=\"num\">l@\n";
	print "<input type=submit name=\"ss\" value=\"@@s@\"><br>\n";
	print "<font color=\"#ff8888\" size=2>Sڂ܂͑IڂɂẴf[^Wv</font><br>\n";
	print "<font color=\"#ff8888\" size=2>f[^̏Wvʂ͕\\݂̂Ńt@Co͂ł܂B</font><br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";

	print "[ f[^ ]<br>\n";
	print "<br>\n";
	print "ΏۍځF<select name=\"rsh\">";
	@head = split(/,/,$head);
	print "<option value=\"all\">SڑΏ\n";
	$i = 0;
	foreach $ehead(@head){
		print "<option value=\"$i\">$ehead\n";
		$i++;
	}
	print "</select>\n";
	print "<input name=\"stxt\" size=20>Ƃ<br>\n";
	print "<input type=radio name=\"sctype\" value=\"in\" checked>܂ނ́@\n";
	print "<input type=radio name=\"sctype\" value=\"un\">܂܂Ȃ\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<center>\n";
	print "<input type=submit name=\"rs\" value=\"@@@\"><br>\n";
	print "</center>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "<br>\n";
	print "</td></tr></table>\n";
	print "</center>\n";
	print "<br></body></html>\n";
	exit 0;
}

